program Laser2;
uses dos,crt,graph,mausb,utimer,ulaser2;
const bildpunkte:word=150;
      nutzbreite=236;
      cx:word=0;
      cy:word=0;
      ausgleich2:word=0;
      ausgleich:word=20;
      data2=888; {LPT2}
      data1=632;{956;} {LPT1}
      x0=1;
      y0=479-257;
      reihen=2;
      drehx:word=0{55};
      drehy:word=0{60};
const maxx:word=0;
      maxy:word=0;
      grafikan:boolean=false;
      graphdriver:integer=0;
      maxpunkte=1000;
      bild1:byte=0;
      aktfarbe:word=255;

Type PPolygon=^TPolygon;
     TPolygon=array[0..maxpunkte] of record x,y,farbe:byte; end;
     PHPolygon=^THPolygon;
     THPolygon=array[0..2*maxpunkte] of record x,y,farbe:byte; end;

     PSkizze=^TSkizze;
     Tskizze=object
       punkt:TPolygon;
       wiederhol,stand,gesch,nummer,maxpunkt:word;
       vorher,weiter:pskizze;
       constructor init(vorganger:PSkizze);
       constructor lad(var f:file;vorganger:PSkizze;anz:byte);
       constructor laden(var f:file);
       function male:char;
       procedure maleklein;
       procedure malegros;
       procedure neu;
       function berechneani(animation:PAnimation;first:boolean):word;
       function berechnebild(var punkte:Tpunkte):word;
       function Upgrade(hPolygon:PHPolygon):word;
       function lange(hpoly:Phpolygon;maxp:word):real;
       function number(nr:byte):PSkizze;
       function letztes:PSkizze;
       function anzahl:byte;
       procedure sichern(var f:file);
       procedure sich(var f:file);
       procedure neuaufbau;
       function maxbild:byte;
       procedure Renumber(n:byte);
       function dauer:word;
       destructor done;
       destructor clear;
     end;

     PShow=^TShow;
     TShow=object
       Pattern:array[0..maxpatterns] of PSkizze;
       aktpattern:byte;
       skizze,aktskizze:PSkizze;
       Patternlist:TPatternlist;
       constructor init;
       constructor laden(name:pathstr);
       procedure ladezusatz(name:pathstr);
       procedure sichern(name:pathstr);
       procedure schiebe(wieviel:shortint);
       procedure nextpattern(r:shortint);
       function handleevent:char;
       procedure berechneanimation;
       procedure berechnebild;
       procedure editpatternlist;
       procedure neuaufbau;
       function numpat:byte;
       function patternlistsize:word;
       procedure removebild;
       procedure kopiere(d:byte);
       procedure loschepattern;
       destructor done;
     end;

     PByte=^Byte;

var show:PShow;
    bilderx,bildbreite:byte;

{$L EGAVGA}
procedure EGAVGAdriver;external;

  procedure error(s:string);
  begin
    if grafikan then closegraph;
    if s<>'' then writeln(s,^g);
    halt(1);
  end;

  procedure grafikein;
  var graphmode,err:integer;
      pfad:string;
      vorh:boolean;
      tasten:word;
  begin
    if (registerbgidriver(@EGAVGAdriver)<0) then begin
       writeln('Fehler beim Anmelden der Grafiktreiber!',^G);
       halt(1);
    end;
    pfad:='';
    repeat
      graphdriver:=detect;
      detectgraph(graphdriver,graphmode);
      if (graphdriver<>graph.vga) then begin
        writeln('Ich gebe Dir einen Tip:');
        writeln('Kauf Dir ''ne VGA Karte !');
        readln;
        halt(1);
      end;
      initgraph(graphdriver,graphmode,pfad);
      err:=graphresult;
      if err<>0 then begin
        writeln(grapherrormsg(err));
        write(^G,'Geben Sie Ihren Grafik Pfad ein : ');
        readln(pfad);
        if pfad='' then halt(1);
      end;
    until err=0;
    grafikan:=true;
    maxx:=getmaxx;
    maxy:=getmaxy;
    mausinit(vorh,tasten);
    if not vorh then error('Keine Maus gefunden');
  end;

  function getname(x,y:word;s:string):string;
  var hs:string;
  begin
    outtextxy(x,y,s);
    directvideo:=false;
    gotoxy(x*84 div maxx,(y+10)*32 div maxy);
    readln(hs);
    getname:=hs;
    directvideo:=true;
    bar(x,y,x+10*length(s),y+25);
  end;

  

  procedure menu;
  var buf:string[8];
  begin
    setcolor(lightred);
    outtextxy(300,300,'H) Halt');
    outtextxy(300,310,'G) Go');
    outtextxy(300,320,'PgUp & PgDn) Patternwechsel');
    outtextxy(300,330,'N) Neu    O) Bild lschen');
    outtextxy(300,340,'W) Weiter $) Pattern lschen');
    outtextxy(300,350,'B) Aktuelles Bild anzeigen');
    outtextxy(300,360,'0..9) Bild mit Nr bearbeiten');
    outtextxy(300,370,'+) nchstes Bild bearbeiten');
    outtextxy(300,380,'-) voriges Bild bearbeiten');
    outtextxy(300,390,'<--) animieren  J) Disco');
    outtextxy(300,400,'S) Sichern      L) Laden   Z) Lade Zusatz');
    outtextxy(300,410,'C) Alles neu    K) Kopiere P) Patternlist');
    outtextxy(300,420,'T) Standbild    D) Dauer   R) Wiederholrate');
    bar(300,430,500,480);
    str(aktfarbe:3,buf);
    outtextxy(300,430,'A) Farbe '+buf);
    str(ausgleich2:4,buf);
    outtextxy(300,440,'Y) Ausgleich2 '+buf);
    str(ausgleich:4,buf);
    outtextxy(300,450,'X) Ausgleich '+buf);
    str(drehx:3,buf);
    outtextxy(300,460,'E) Drehwinkel X '+buf);
    str(drehy:3,buf);
    outtextxy(460,460,'F) Y '+buf);
    str(pitch:7:5,buf);
    outtextxy(300,470,'U) Pitch: '+buf);
  end;



  function TSkizze.male:char;
  var lastx,lasty,xpos,ypos,tasten,altx,alty,letztx,letzty:word;
      gesetzt:boolean;
      malmodus:boolean;
      ein:char;

    procedure newpoint(x,y:word);
    begin
      punkt[maxpunkt].x:=x;
      punkt[maxpunkt].y:=y;
      punkt[maxpunkt].farbe:=aktfarbe;
      inc(maxpunkt);
      lastx:=x;lasty:=y;
      if malmodus then repeat until not mauskeypressed;
    end;

    procedure initbild;
    var rand:byte;
        hbild:pskizze;
        buf,buf2:string[6];
    begin
      mausunsicht;
      bar(x0,y0,x0+256,y0+256);
      setcolor(blue);
      str(nummer:3,buf);
      str(gesch:3,buf2);
      buf:=buf+buf2;
      outtextxy(x0+5,y0+5,buf);
      setcolor(darkgray);
      if vorher<>nil then vorher^.malegros
      else begin
        hbild:=letztes;
        if (hbild<>nil) and (hbild<>@self) then hbild^.malegros;
      end;
      malmodus:=false;
      rand:=(256-nutzbreite) div 2;
      mausminmaxx(x0+rand,x0+255-rand);
      mausminmaxy(y0+rand,y0+255-rand);
      mausgrafikcursor(0,16,pinsel);
      setcolor(lightred);
      if maxpunkt>0 then begin
        malegros;
        altx:=punkt[pred(maxpunkt)].x+x0;
        alty:=punkt[pred(maxpunkt)].y+y0;
        gesetzt:=true;
      end else begin
        altx:=x0+127;
        alty:=y0+127;
        gesetzt:=false;
      end;
      maussetpos(altx,alty);
      xpos:=altx;
      ypos:=alty;
      letztx:=altx;
      letzty:=alty;
      lastx:=altx-x0;
      lasty:=alty-y0;
      setwritemode(xorput);
      maussicht;maussicht;
    end;

    procedure getzahl(var z:word;u,o:word;t:string);
    var d:word;
        er:integer;
    begin
      val(getname(300,260,t),d,er);
      if (er=0) and (d<=o) and (d>=u) then z:=d;
      menu;
    end;

    procedure getrealzahl(var r:real;t:string);
    var d:real;
        er:integer;
    begin
      val(getname(300,260,t),d,er);
      if (er=0) then r:=d;
      menu;
    end;

  var er:integer;
      d:word;
  begin
    initbild;
    repeat
      repeat
        repeat
          maustastpos(tasten,xpos,ypos);
        until (xpos<>altx) or (ypos<>alty) or keypressed or (tasten<>0);
        if gesetzt and ((xpos<>altx) or (ypos<>alty)) then begin
          mausunsicht;
          line(letztx,letzty,altx,alty);
          line(letztx,letzty,xpos,ypos);
          maussicht;
          altx:=xpos;
          alty:=ypos;
        end;
      until keypressed or (tasten<>0);
      if (tasten=1) and ((xpos<>letztx) or (ypos<>letzty)) then begin
        if malmodus or (sqrt(sqr(longint(xpos-x0)-lastx)+sqr(longint(ypos-y0)-lasty))>5) then begin
          newpoint(xpos-x0,ypos-y0);
          letztx:=xpos;letzty:=ypos;
          altx:=xpos;alty:=ypos;
          gesetzt:=true;
        end;
      end;
      ein:='.';
      while keypressed do ein:=upcase(readkey);
      case ein of
        'H':Stop;
        'G':Continue;
        'M':Malmodus:=true;
        'N':begin neu;initbild; end;
        'T':begin
              getzahl(stand,0,9999,'Gebe die Standbilddauer ein:');
              maleklein;
            end;
        'R':begin
          getzahl(wiederhol,0,100,'Gebe die Wiederholfrequenz ein (1..100):');
          maleklein;
        end;
        'D': begin
          getzahl(gesch,0,9999,'Gebe die berblenddauer ein:');
          maleklein;
        end;
        'X':getzahl(ausgleich,0,100,'Gebe die Korrektur ein (0..100):');
        'Y':getzahl(ausgleich2,0,64000,'Gebe die Korrektur ein (0..64000):');
{        'Y':getzahl(cy,0,100,'Gebe die Y-Korrektur ein (0..100):');}
        'E':getzahl(drehx,0,359,'Gebe den Drehwinkel X ein (0..359):');
        'F':getzahl(drehy,0,359,'Gebe den Drehwinkel Y ein (0..359):');
        'A':getzahl(aktfarbe,0,255,'Gebe die Helligkeit (0..255):');
        'U':getrealzahl(pitch,'Gebe den Pich ein:');
      end;
      setwritemode(xorput);
      setcolor(lightred);
    until (ein=#13) or (ein=#27) or (ein='W') or (ein='S') or (ein='+') or
          (ein='-') or (ein='B') or (ein in ['0'..'9']) or (tasten=2) or
          (ein='L') or (ein='C') or (ein=#81) or (ein=#73) or (ein='*') or
          (ein='/') or (ein='P') or (ein='O') or (ein='K') or (ein='$') or
          (ein='Z') or (ein='J');
    if tasten=2 then ein:='W';
    line(letztx,letzty,altx,alty);
    line(x0+punkt[0].x,y0+punkt[0].y,x0+punkt[pred(maxpunkt)].x,y0+punkt[pred(maxpunkt)].y);
    while mauskeypressed do;
    mausunsicht;
    male:=ein;
  end;

  procedure newscreen;
  var n:byte;
  begin
    cleardevice;
    setfillstyle(solidfill,0);
    setcolor(lightgreen);
    moveto(x0+257,pred(y0));
    lineto(x0+257,y0+257);
    lineto(pred(x0),y0+257);
    lineto(pred(x0),pred(y0));
    lineto(x0+257,pred(y0));
    bildbreite:=(maxy-258) div reihen;
    bilderx:=(maxx div bildbreite);
    for n:=0 to reihen do line(0,n*bildbreite,bilderx*bildbreite,n*bildbreite);
    for n:=0 to bilderx do line(n*bildbreite,0,n*bildbreite,reihen*bildbreite);
    menu;
  end;

  constructor TSkizze.init(vorganger:PSkizze);
  begin
    vorher:=vorganger;
    if vorganger<>nil then begin
      weiter:=vorganger^.weiter;
      if weiter<>nil then weiter^.vorher:=@self;
      vorganger^.weiter:=@self;
      renumber(succ(vorganger^.nummer));
    end else begin
      nummer:=0;
      weiter:=nil;
    end;
    stand:=0;
    gesch:=16;
    wiederhol:=18;
    maxpunkt:=0;
  end;

  procedure TSkizze.sichern(var f:file);
  var anz:byte;
  begin
    anz:=anzahl;
    blockwrite(f,anz,sizeof(byte));
    sich(f);
  end;

  procedure TSkizze.sich(var f:file);
  begin
    blockwrite(f,maxpunkt,sizeof(maxpunkt));
    blockwrite(f,stand,sizeof(stand));
    blockwrite(f,gesch,sizeof(gesch));
    blockwrite(f,wiederhol,sizeof(wiederhol));
    blockwrite(f,nummer,sizeof(nummer));
    blockwrite(f,punkt,3*maxpunkt*sizeof(byte));
    if weiter<>nil then weiter^.sich(f);
  end;

  constructor TSkizze.lad(var f:file;vorganger:PSkizze;anz:byte);
  var _hskizze:pskizze;
  begin
    init(vorganger);
    blockread(f,maxpunkt,sizeof(maxpunkt));
    blockread(f,stand,sizeof(stand));
    blockread(f,gesch,sizeof(gesch));
    blockread(f,wiederhol,sizeof(wiederhol));
    blockread(f,nummer,sizeof(nummer));
    blockread(f,punkt,3*maxpunkt*sizeof(byte));
    maleklein;
    if anz>=2 then new(_hskizze,lad(f,@self,pred(anz)));
  end;

  constructor TSkizze.laden(var f:file);
  var anz:byte;
  begin
    blockread(f,anz,sizeof(byte));
    if anz>0 then lad(f,nil,anz) else init(nil);
  end;

  destructor TSkizze.done;
  begin
    if vorher<>nil then vorher^.weiter:=weiter;
    if weiter<>nil then weiter^.vorher:=vorher;
  end;

  procedure TSkizze.Renumber(n:byte);
  begin
    nummer:=n;
    if weiter<>nil then weiter^.renumber(succ(n));
  end;

  function TSkizze.dauer:word;
  var mydauer:word;
  begin
    sound(200);
    mydauer:=(stand+gesch)*100 div wiederhol;
    if weiter<>nil then dauer:=mydauer+weiter^.dauer else dauer:=mydauer;
    nosound;
  end;

  procedure TSkizze.neuaufbau;
  begin
    maleklein;
    if weiter<>nil then weiter^.neuaufbau;
  end;

  function TSkizze.maxbild:byte;
  begin
    if weiter<>nil then maxbild:=weiter^.maxbild else maxbild:=nummer;
  end;

  destructor TSkizze.clear;
  begin
    if weiter<>nil then dispose(weiter,clear);
  end;

  procedure TSkizze.neu;
  begin
    maxpunkt:=0;
    maleklein;
  end;

  procedure TSkizze.maleklein;
  var myx,myy:byte;
      n:word;
      buf,buf2:string[6];

    function calcx(x:byte):word;
    begin
      calcx:=succ(myx*bildbreite)+word(x)*(bildbreite-2) div 256;
    end;

    function calcy(y:byte):word;
    begin
      calcy:=succ(myy*bildbreite)+word(y)*(bildbreite-2) div 256;
    end;

  begin
    if (nummer<bild1) or (nummer>=bild1+reihen*bilderx) then exit;
    myx:=(nummer-bild1) mod bilderx;
    myy:=(nummer-bild1) div bilderx;
    if myy>reihen then exit;
    bar(succ(myx*bildbreite),succ(myy*bildbreite),pred(succ(myx)*bildbreite),pred(succ(myy)*bildbreite));
    setcolor(red);
    setwritemode(normalput);
    if maxpunkt>0 then begin
      moveto(calcx(punkt[0].x),calcy(punkt[0].y));
      for n:=0 to pred(maxpunkt) do lineto(calcx(punkt[n].x),calcy(punkt[n].y));
      lineto(calcx(punkt[0].x),calcy(punkt[0].y));
    end;
    setcolor(blue);
    str(nummer:3,buf);
    str(wiederhol:3,buf2);
    outtextxy(myx*bildbreite+5,myy*bildbreite+5,'Nr'+buf+' Wi'+buf2);
    str(stand:3,buf);
    str(gesch:3,buf2);
    outtextxy(myx*bildbreite+5,myy*bildbreite+15,'St'+buf+' b'+buf2);
  end;

  procedure TSkizze.malegros;
  var n:word;
  begin
    setwritemode(normalput);
    if maxpunkt>0 then begin
      moveto(punkt[0].x+x0,punkt[0].y+y0);
      for n:=0 to pred(maxpunkt) do lineto(punkt[n].x+x0,punkt[n].y+y0);
      lineto(punkt[0].x+x0,punkt[0].y+y0);
    end;
  end;


  function TSkizze.lange(hpoly:Phpolygon;maxp:word):real;
  var l:real;
      n:word;
  begin
    l:=0;
    if maxp<>0 then begin
    for n:=0 to maxp-2 do
     l:=l+(hpoly^[n].farbe/255)*sqrt(sqr(longint(hpoly^[n].x)-hpoly^[succ(n)].x)+
               sqr(longint(hpoly^[n].y)-hpoly^[succ(n)].y));
    l:=l+(hpoly^[pred(maxp)].farbe/255)*sqrt(sqr(longint(hpoly^[pred(maxp)].x)-hpoly^[0].x)+
               sqr(longint(hpoly^[pred(maxp)].y)-hpoly^[0].y));
    end;
    lange:=l;
  end;


  function TSkizze.Upgrade(hPolygon:PHPolygon):word;
  var altx,alty,aktx,akty,nextx,nexty,aktfarbe,nextfarbe:byte;
      aktpunkt,nextp:word;
      n:integer;
      f,l1,l2,r1x,r1y,r2x,r2y:real;

    procedure addpunkt(ax,ay:real;afarbe:byte);
    begin
      with hpolygon^[aktpunkt] do begin
        if ax<0 then x:=0 else if ax>255 then x:=255 else x:=round(ax);
        if ay<0 then y:=0 else if ay>255 then y:=255 else y:=round(ay);
        farbe:=afarbe;
        inc(aktpunkt);
        {if aktpunkt=0 then moveto(x,y) else lineto(x,y);}
      end;
    end;

  begin
    aktpunkt:=0;
    altx:=punkt[pred(maxpunkt)].x;
    alty:=punkt[pred(maxpunkt)].y;
    n:=-1;
    repeat
      inc(n);
      aktx:=punkt[n].x;
      akty:=punkt[n].y;
    until (aktx<>altx) or (akty<>alty);
    aktfarbe:=punkt[n].farbe;
    r1x:=aktx-altx;r1y:=akty-alty;
    l1:=sqrt(r1x*r1x+r1y*r1y);
    r1x:=r1x/l1;r1y:=r1y/l1;
    while n<=maxpunkt do with punkt[n] do begin
      repeat
{        if n<pred(maxpunkte) then nextp:=n
        else if n=maxpunkt then nextp:=1 else nextp:=0;}
        if n<maxpunkt then nextp:=n else nextp:=0;
{        if n<pred(maxpunkt) then nextp:=n
        else if n=maxpunkt then nextp:=1 else nextp:=0;}
        nextx:=punkt[nextp].x;
        nexty:=punkt[nextp].y;
        r2x:=nextx-aktx;r2y:=nexty-akty;
        l2:=sqrt(r2x*r2x+r2y*r2y);
        if l2=0 then inc(n); if n>maxpunkt then begin
          upgrade:=aktpunkt;
          exit;
        end;
      until l2<>0;
      nextfarbe:=punkt[nextp].farbe;
      r2x:=r2x/l2;r2y:=r2y/l2;
      f:=ausgleich*(r1x*r2x+r1y*r2y+1)*l1/64;
      addpunkt(aktx+f*r1x,akty+f*r1y,aktfarbe);
      if f<l2 then addpunkt(aktx+f*r2x,akty+f*r2y,aktfarbe);
      if n<maxpunkt then addpunkt(nextx,nexty,nextfarbe);
      aktfarbe:=nextfarbe;
      altx:=aktx;alty:=akty;
      aktx:=nextx;akty:=nexty;
      r1x:=r2x;r1y:=r2y;l1:=l2;
      inc(n);
    end;
    upgrade:=aktpunkt;
  end;

  function TSkizze.berechnebild(var punkte:Tpunkte):word;
  type Thkoords=array[0..1] of record x,y:byte; end;
       TMatrix=array[0..1,0..1] of integer;
  var d:real;
      aktpunkt:word;
      color:boolean;
      altdy,altdx,altx,alty:integer;
      okoor:thkoords;
      m:TMatrix;

    procedure calcpoint(x,y:PByte;ax,ay:byte);
    var dx,dy,ddx,ddy,hx,hy:integer;
        h:longint;
    begin
      dx:=altx-ax;
      ddx:=altdx-dx;
      dy:=alty-ay;
      ddy:=altdy-dy;
      hx:=ax+ddx*cx;
      hy:=ay+ddy*cy;

      if ausgleich2<>0 then begin
        h:=hx-127;
        hx:=round(hx+h*h*h div ausgleich2);
        h:=hy-127;
        hy:=round(hy+h*h*h div ausgleich2);
      end;

      if hx>255 then hx:=255 else if hx<0 then hx:=0;
      if hy>255 then hy:=255 else if hy<0 then hy:=0;
      x^:=hx;y^:=hy;
      if color then setcolor(yellow) else setcolor(green);
      color:=not color;
      if aktpunkt<3 then moveto(x^+x0,y^+y0) else lineto(x^+x0,y^+y0);
      altdy:=dy;
      altdx:=dx;
      altx:=ax;
      alty:=ay;
    end;

    procedure mulmat(var x,y:byte);
    var hx,hy:integer;
    begin
      hx:=(((longint(x)-128)*m[0,0]+longint(y-128)*m[0,1]) div 1024) +128;
      hy:=(((longint(x)-128)*m[1,0]+longint(y-128)*m[1,1]) div 1024) +128;
      if hx>255 then hx:=255 else if hx<0 then hx:=0;
      if hy>255 then hy:=255 else if hy<0 then hy:=0;
      x:=hx;
      y:=hy;
    end;

    procedure addpunkt(ax,ay:byte);
    begin
      mulmat(ax,ay);
      with punkte[aktpunkt] do begin
        if aktpunkt=0 then begin
          okoor[0].x:=ax;
          okoor[0].y:=ay;
        end else if aktpunkt=1 then begin
          okoor[1].x:=ax;
          okoor[1].y:=ay;
        end;
        calcpoint(@x,@y,ax,ay);
        inc(aktpunkt);
      end;
    end;

    procedure korrigiere;
    begin
      calcpoint(@punkte[0].x,@punkte[0].y,okoor[0].x,okoor[0].y);
      calcpoint(@punkte[1].x,@punkte[1].y,okoor[1].x,okoor[1].y);
    end;

    procedure berechnedrehmatrix;
    begin
      m[0,0]:=round(cos(drehx*pi/360)*1024);
      m[1,0]:=-round(sin(drehx*pi/360)*1024);;
      m[1,1]:=round(cos(drehy*pi/360)*1024);
      m[0,1]:=round(sin(drehy*pi/360)*1024);
    end;

    function kopiere(hpol:PHpolygon):word;
    begin
      move(punkt,hpol^,3*sizeof(byte)*maxpunkt);
      kopiere:=maxpunkt;
    end;

  var rest,dl,dx,dy:real;
      n,k,h,next,maxp,frequenz:word;
      x,y:byte;
      hPolygon:PhPolygon;
  begin
    if maxpunkt>=2 then begin
      berechnedrehmatrix;
      new(hpolygon);
      if ausgleich<>0 then maxp:=Upgrade(hpolygon)
      else maxp:=kopiere(hpolygon);
      mausunsicht;
      setwritemode(normalput);
      frequenz:=wiederhol*bildpunkte;
      d:=lange(hpolygon,maxp)/bildpunkte;
      aktpunkt:=0;
      rest:=0;
      altdy:=0;
      altdx:=0;
      altx:=0;
      alty:=0;
      addpunkt(hPolygon^[0].x,hPolygon^[0].y);
      for n:=0 to pred(maxp) do begin
        if n=pred(maxp) then next:=0 else next:=succ(n);
        x:=hPolygon^[n].x;
        y:=hPolygon^[n].y;
        dx:=integer(hPolygon^[next].x)-integer(x);
        dy:=integer(hPolygon^[next].y)-integer(y);
        dl:=sqrt(dx*dx+dy*dy)*(hPolygon^[n].farbe/255);
        if dl<>0 then begin
          dx:=dx/dl;
          dy:=dy/dl;
        end;
        if dl>(d-rest) then begin
          addpunkt(x+round((d-rest)*dx),
                   y+round((d-rest)*dy));
          k:=trunc((dl-(d-rest))/d);
          for h:=2 to succ(k) do addpunkt(x+round((h*d-rest)*dx),
                                        y+round((h*d-rest)*dy));
          rest:=dl-(succ(k)*d-rest);{ rest<d }
        end else rest:=dl+rest;
      end;
      while aktpunkt<bildpunkte do
       addpunkt(punkte[pred(aktpunkt)].x,punkte[pred(aktpunkt)].y);
      korrigiere;
      if aktpunkt>bildpunkte then aktpunkt:=bildpunkte;
      maussicht;
      berechnebild:=aktpunkt;
      dispose(hpolygon);
    end else berechnebild:=0;
  end;

  function TSkizze.number(nr:byte):PSkizze;
  begin
    if (nr>0) and (weiter<>nil) then number:=weiter^.number(pred(nr))
    else number:=@self;
  end;

  function TSkizze.letztes:PSkizze;
  begin
    if weiter<>nil then letztes:=weiter^.letztes
    else letztes:=@self;
  end;

  function TSkizze.anzahl:byte;
  begin
    if weiter<>nil then anzahl:=succ(weiter^.anzahl) else anzahl:=1;
  end;

  constructor TShow.init;
  var n:word;
  begin
    fillchar(pattern,sizeof(pattern),#0);
    aktskizze:=new(PSkizze,init(nil));
    pattern[0]:=aktskizze;
    skizze:=aktskizze;
    aktpattern:=0;
    for n:=1 to maxpattern do with patternlist[n] do begin
      nr:=$ff;
      rep:=0;
      status:=0;
    end;
    with patternlist[0] do begin nr:=0;rep:=0;status:=0; end;
  end;

  procedure tshow.ladezusatz(name:pathstr);
  var search:searchrec;
      numpattern,n,num:byte;
      f:file;
      patlength:word;
  begin
    search.name:=name;
    findfirst(name,anyfile,search);
    if doserror<>0 then init else begin
      assign(f,name);
      reset(f,1);
      blockread(f,patlength,sizeof(patlength));
      seek(f,2+3*patlength);
      num:=numpat;
      blockread(f,numpattern,sizeof(numpattern));
      if numpattern<>0 then begin
        for n:=num to num+pred(numpattern) do new(pattern[n],laden(f));
        aktskizze:=pattern[num];
        aktpattern:=num;
        skizze:=aktskizze;
      end;
      close(f);
    end;
  end;

  constructor tshow.laden(name:pathstr);
  var search:searchrec;
      numpattern,n:byte;
      f:file;
      patlength:word;


{  type topat=array[0..maxpattern] of byte;
  var opat:topat;}

  begin
    init;
    search.name:=name;
    findfirst(name,anyfile,search);
    if doserror<>0 then init else begin
      assign(f,name);
      reset(f,1);
      blockread(f,patlength,sizeof(patlength));
      if patlength>succ(maxpattern) then patlength:=succ(maxpattern);

      blockread(f,patternlist,3*patlength);
      {blockread(f,opat,patlength);
      for n:=0 to pred(patlength) do patternlist[n].nr:=opat[n];}

      blockread(f,numpattern,sizeof(numpattern));
      if numpattern=0 then init else begin
        for n:=0 to pred(numpattern) do new(pattern[n],laden(f));
        aktskizze:=pattern[0];
        aktpattern:=0;
        skizze:=aktskizze;
      end;
      close(f);
    end;
  end;

  function TShow.numpat:byte;
  var num:byte;
  begin
    num:=0;
    while (pattern[num]<>nil) and (num<maxpatterns) do inc(num);
    numpat:=num;
  end;

  function TShow.patternlistsize:word;
  var num:word;
  begin
    num:=0;
    while (patternlist[num].nr<>$ff) and (num<maxpattern) do inc(num);
    patternlistsize:=num;
  end;

  procedure Tshow.sichern(name:pathstr);
  var n,nu:byte;
      f:file;
      patlength:word;
  begin
    if name<>'' then begin
      assign(f,name);
      rewrite(f,1);
      patlength:=patternlistsize;
      blockwrite(f,patlength,sizeof(patlength));
      blockwrite(f,patternlist,3*patlength);
      nu:=numpat;
      blockwrite(f,nu,sizeof(byte));
      for n:=0 to pred(nu) do pattern[n]^.sichern(f);
      close(f);
    end;
  end;

  function TSkizze.berechneani(animation:PAnimation;first:boolean):word;
  var aktpunkte:word;
      punkte:PPunkte;
      var hbild:PBild;
  begin
    if maxpunkt>=2 then begin
      new(Punkte);
      aktpunkte:=berechnebild(punkte^);
      new(hbild,init(punkte^,stand,gesch,wiederhol*bildpunkte,bildpunkte));
      dispose(punkte);
      if aktpunkte>1 then begin
        if first then animation^.addpattern(hbild,anzahl)
        else animation^.addbild(hbild);
        if weiter<>nil then berechneani:=weiter^.berechneani(animation,false);
      end else berechneani:=0;
    end else berechneani:=0;
  end;

  procedure TShow.berechneanimation;
  var animation:PAnimation;
      fehler:boolean;
      n:byte;
      punktzahl:word;
  begin
    if patternlist[0].nr<>255 then begin
      new(animation,init(patternlist,numpat));
      fehler:=false;
      for n:=0 to pred(numpat) do begin
        punktzahl:=pattern[n]^.berechneani(animation,true);
        fehler:=fehler or (punktzahl<2);
      end;
      if not fehler then newanimation(animation) else dispose(animation);
    end;
  end;

  procedure TShow.berechnebild;
  var punktezahl:word;
      hbild:PBild;
      punkte:PPunkte;
  begin
    new(Punkte);
    punktezahl:=aktskizze^.berechnebild(punkte^);
    if punktezahl>1 then begin
      new(hbild,init(punkte^,0,0,punktezahl*aktskizze^.wiederhol,punktezahl));
      newbild(hbild);
    end;
    dispose(punkte);
  end;

  procedure TShow.schiebe(wieviel:shortint);
  var max:byte;

    procedure clearbild(n:byte);
    var myx,myy:byte;
    begin
      myx:=n mod bilderx;
      myy:=n div bilderx;
      bar(succ(myx*bildbreite),succ(myy*bildbreite),pred(succ(myx)*bildbreite),pred(succ(myy)*bildbreite));
    end;

  begin
    max:=skizze^.maxbild;
    if (integer(bild1)+wieviel>=0) and (integer(bild1)+wieviel<=max) then begin
      inc(bild1,wieviel);
      skizze^.neuaufbau;
      if (max-bild1)<(bilderx*reihen) then clearbild(succ(max-bild1));
    end;
  end;

  procedure TShow.nextpattern(r:shortint);
  begin
    if r<0 then begin
      if aktpattern>=-r then aktpattern:=aktpattern+r;
    end else if integer(aktpattern)+r<=255 then inc(aktpattern,r);
    if pattern[aktpattern]<>nil then skizze:=pattern[aktpattern]
    else begin
      skizze:=new(PSkizze,init(nil));
      pattern[aktpattern]:=skizze;
    end;
    aktskizze:=skizze;
    neuaufbau;
  end;

  procedure TShow.neuaufbau;
  var buf,buf1,buf2:string[3];
      zeit:word;
  begin
    newscreen;
    skizze^.neuaufbau;
    zeit:=skizze^.dauer;
    str(aktpattern:3,buf);
    str((zeit div 100):2,buf1);
    str((zeit mod 100):2,buf2);
    outtextxy(300,230,'Pattern Nr: '+buf+' Lnge: '+buf1+','+buf2+' sec');
  end;

  procedure TShow.removebild;
  var hskizze:PSkizze;
      n:byte;
  begin
    if skizze=aktskizze then begin
      if skizze^.weiter<>nil then begin
        n:=0;
        while (pattern[n]<>skizze) and (n<maxpatterns) do inc(n);
        if pattern[n]=skizze then pattern[n]:=skizze^.weiter;
        skizze:=skizze^.weiter;
        hskizze:=aktskizze;
        aktskizze:=skizze;
      end else exit;
    end else begin
      hskizze:=aktskizze;
      aktskizze:=aktskizze^.weiter;
      if aktskizze=nil then aktskizze:=skizze;
    end;
    dispose(hskizze,done);
    skizze^.renumber(0);
    neuaufbau;
  end;

  procedure TShow.loschepattern;
  var m,c,nummer,n:byte;
  begin
    n:=0;
    while (pattern[n]<>skizze) and (n<maxpattern) do inc(n);
    if (pattern[n]<>skizze) or ((n=0) and (pattern[1]=nil)) then exit;
    nummer:=n;
    dispose(skizze,done);
    while (n<maxpatterns) and (pattern[n]<>nil) do begin
      pattern[n]:=pattern[succ(n)];
      inc(n);
    end;
    m:=0;
    c:=0;
    while (patternlist[m].nr<>$ff) and (m<maxpattern) do begin
      if patternlist[m].nr<>nummer then begin
        patternlist[c]:=patternlist[m];
        if patternlist[m].nr>nummer then
          patternlist[c].nr:=pred(patternlist[m].nr);
        inc(c);
      end;
      inc(m);
    end;
    patternlist[c].nr:=$ff;
    if nummer>0 then aktpattern:=pred(nummer) else aktpattern:=0;
    skizze:=pattern[aktpattern];
    aktskizze:=skizze;
    neuaufbau;
  end;

  procedure TShow.kopiere(d:byte);
  var dskizze:PSkizze;
      n:byte;
  begin
    if (aktskizze^.nummer<>d) and (aktskizze^.nummer<>(d-1)) then begin
      dskizze:=skizze^.number(d);
      if skizze=aktskizze then begin
        n:=0;
        while (pattern[n]<>skizze) and (n<maxpatterns) do inc(n);
        if pattern[n]=skizze then pattern[n]:=skizze^.weiter;
        skizze:=skizze^.weiter;
      end;
      with aktskizze^ do begin
        if vorher<>nil then vorher^.weiter:=weiter;
        if weiter<>nil then weiter^.vorher:=vorher;
        weiter:=dskizze;
        vorher:=dskizze^.vorher;
        if vorher<>nil then vorher^.weiter:=aktskizze;
        dskizze^.vorher:=aktskizze;
      end;
      skizze^.renumber(0);
      neuaufbau;
    end;
  end;

  procedure TShow.editpatternlist;
  type PPatternzeit=^TPAtternzeit;
       TPatternzeit=array[0..maxpatterns] of word;
  var ein:char;
      oldpat,aktpat,n:word;
      num:byte;
      patternzeit:PPatternzeit;
      verandert:boolean;

    procedure malenilpattern;
    var n:byte;
    begin
      bar(0,0,maxx,pred(y0));
      setfillstyle(solidfill,0);
      setcolor(lightgreen);
      bildbreite:=(maxy-258) div reihen;
      bilderx:=(maxx div bildbreite);
      for n:=0 to reihen do line(0,n*bildbreite,bilderx*bildbreite,n*bildbreite);
      for n:=0 to bilderx do line(n*bildbreite,0,n*bildbreite,reihen*bildbreite);
    end;

    procedure maleaktpattern;
    var buf2,buf3,buf1,buf,bufrep:string[3];
        bufr:string[9];
        x,y:word;
    begin
      malenilpattern;
      if patternlist[aktpat].nr<>$FF then pattern[patternlist[aktpat].nr]^.neuaufbau;
      setcolor(green);
      bar(0,y0+10,639,y0+19);
      str(patternlist[aktpat].nr:3,buf1);
      str(succ(patternlist[aktpat].rep):3,bufrep);
      if (patternlist[aktpat].status and sfback)>0 then bufr:='rckwrts'
      else bufr:='vorwrts';
      str(aktpat:3,buf);
      str((patternzeit^[patternlist[aktpat].nr] div 100):2,buf2);
      str((patternzeit^[patternlist[aktpat].nr] mod 100):2,buf3);
      outtextxy(0,y0+10,'Nr: '+buf+' Pattern: '+buf1+
        ' Lnge: '+buf2+','+buf3+' sec  Wiederholungen: '
        +bufrep+' Richtung: '+bufr);
      y:=y0+20+(aktpat div 10)*30;
      x:=x0+(aktpat mod 10)*8*8;
      bar(x,y,x+7*8,y+9);
      if (patternlist[aktpat].status and sfback)>0 then bufr:='-'
      else bufr:='+';
      outtextxy(x,y,buf1+bufr+bufrep);
      setcolor(yellow);
      bar(x,y+10,x+5*8,y+19);
      outtextxy(x,y+10,buf2+','+buf3);
    end;

    procedure malepatternnummer(n:word;c:byte);
    var buf,bufrep:string[3];
        x,y:word;
        bufr:char;
    begin
      setcolor(c);
      str(patternlist[n].nr:3,buf);
      str(succ(patternlist[n].rep):3,bufrep);
      if (patternlist[n].status and sfback)>0 then bufr:='-'
      else bufr:='+';
      y:=y0+20+(n div 10)*30;
      x:=x0+(n mod 10)*8*8;
      bar(x,y,x+7*8,y+9);
      outtextxy(x,y,buf+bufr+bufrep);
    end;

    procedure malepatternlist;
    var buf,bufrep:string[3];
        n,x,y:word;
        bufr:char;
    begin
      setcolor(blue);
      for n:=0 to 99 do begin
        str(patternlist[n].nr:3,buf);
        str(succ(patternlist[n].rep):3,bufrep);
        if (patternlist[n].status and sfback)>0 then bufr:='-'
        else bufr:='+';
        y:=y0+20+(n div 10)*30;
        x:=x0+(n mod 10)*8*8;
        outtextxy(x,y,buf+bufr+bufrep);
      end;
    end;

    procedure malepatternzeit;
    var n:byte;
        z:longint;
        buf1,buf2,buf3:string[3];
        x,y:word;
    begin
      setcolor(yellow);
      z:=0;
      n:=0;
      while (patternlist[n].nr<>$ff) and (n<maxpattern) do begin
        z:=z+patternzeit^[patternlist[n].nr]*succ(patternlist[n].rep);
        y:=y0+30+(n div 10)*30;
        x:=x0+(n mod 10)*8*8;
        str((patternzeit^[patternlist[n].nr] mod 100):2,buf2);
        str((patternzeit^[patternlist[n].nr] div 100):2,buf1);
        bar(x,y,x+5*8,y+9);
        outtextxy(x,y,buf1+','+buf2);
        str((z div 6000):2,buf1);
        str(((z div 100) mod 60):2,buf2);
        str((z mod 100):2,buf3);
        bar(x,y+10,x+8*8,y+19);
        outtextxy(x,y+10,buf1+':'+buf2+','+buf3);
        inc(n);
      end;
    end;

    function maxpat:word;
    var n:worD;
    begin
      n:=0;
      while patternlist[n].nr<>$FF do inc(n);
      maxpat:=n;
    end;

  begin
    if maxavail>sizeof(patternzeit) then new(patternzeit)
    else exit;
    cleardevice;
    malenilpattern;
    n:=0;
    while (pattern[n]<>nil) and (n<maxpatterns) do begin
      patternzeit^[n]:=pattern[n]^.dauer;
      inc(n);
    end;
    patternzeit^[255]:=0;
    malepatternlist;
    aktpat:=0;
    num:=pred(numpat);
    maleaktpattern;
    verandert:=false;
    malepatternzeit;
    repeat
      repeat until keypressed;
      while keypressed do ein:=readkey;
      oldpat:=aktpat;
      case ein of
        #75:if aktpat>0 then dec(aktpat)
              else aktpat:=maxpat;
        #77:if aktpat<maxpat then inc(aktpat)
              else aktpat:=0;
        #72:begin
              if patternlist[aktpat].nr=$ff then patternlist[aktpat].nr:=num
              else begin
                if patternlist[aktpat].nr>0 then dec(patternlist[aktpat].nr)
                else patternlist[aktpat].nr:=$ff;
              end;
            end;
        #80:begin
              if patternlist[aktpat].nr=$ff then patternlist[aktpat].nr:=0
              else begin
                if patternlist[aktpat].nr<num then inc(patternlist[aktpat].nr)
                else patternlist[aktpat].nr:=$ff;
              end;
            end;
        '+':patternlist[aktpat].status:=0;
        '-':patternlist[aktpat].status:=sfback;
        '*':inc(patternlist[aktpat].rep);
        '/':if patternlist[aktpat].rep>0 then dec(patternlist[aktpat].rep);
      end;
      if ein in [#72,#80] then verandert:=true;
      if ein in[#75,#77,#72,#80] then maleaktpattern;
      if (ein in [#75,#77]) and verandert then begin
        verandert:=false;
        malepatternzeit;
      end;
      if ein in['+','-','/','*'] then malepatternnummer(aktpat,green);
      if oldpat<>aktpat then malepatternnummer(oldpat,blue);
    until ein=#27;
    neuaufbau;
    dispose(patternzeit);
  end;

  destructor tshow.done;
  var n:byte;
  begin
    n:=0;
    while pattern[n]<>nil do begin
      dispose(pattern[n],done);
      inc(n);
    end;
  end;

  function tshow.handleevent:char;
  var ein:char;
      n:byte; {nur zum test}

    function getzahl(u,o:word;t:string):word;
    var d:word;
        er:integer;
    begin
      val(getname(300,260,t),d,er);
      if (er=0) and (d<=o) and (d>=u) then getzahl:=d else getzahl:=0;
    end;

    procedure disco;
    var ein:char;
    begin
      berechneanimation;
      repeat
        repeat until keypressed;
        while keypressed do ein:=readkey;
        if ein>='0' then playpattern(byte(ein)-byte('0'));
      until ein=#27;
    end;

  begin
    ein:=aktskizze^.male;
    aktskizze^.maleklein;
    case ein of
      #73:nextpattern(-1);
      #81:nextpattern(1);
      '*':schiebe(1);
      '/':schiebe(-1);
      'W':begin
            if aktskizze^.weiter=nil then aktskizze:=new(PSkizze,init(aktskizze))
            else aktskizze:=aktskizze^.weiter;
          end;
      'B':berechnebild;
      #13:berechneanimation;
      'J':disco;
      '0'..'9':aktskizze:=skizze^.number(byte(ein)-byte('0'));
      '+':begin
            aktskizze:=aktskizze^.weiter;
            if aktskizze=nil then aktskizze:=skizze;
          end;
      '-':begin
            aktskizze:=aktskizze^.vorher;
            if aktskizze=nil then aktskizze:=skizze^.number(255);
          end;
      'S':sichern(getname(280,260,'Gebe den Namen ein:')+'.ani');
      'P':editpatternlist;
      'O':removebild;
      'K':kopiere(getzahl(0,skizze^.anzahl-2,'Vor welches Bild soll kopiert werden ?'));
      '$':loschepattern;
      'Z':ladezusatz(getname(300,260,'Gebe den Namen der zustzlichen Show ein:')+'.ani');
    end;
    
{testroutine
    directvideo:=false;
      n:=0;
    while (pattern[n]<>nil) and (n<maxpatterns) do begin
      pattern[n]^.dauer;
      inc(n);
    end;
    directvideo:=true;}

    handleevent:=ein;
  end;

var ein:char;

 {   search:searchrec;}

begin
  grafikein;
  newscreen;

{  directvideo:=false;
  search.name:='boot*.ani';
  findfirst('boot*.ani',anyfile,search);
  while doserror=0 do begin
    writeln(search.name);
    new(show,laden(search.name));
    show^.sichern(copy(search.name,1,pred(pos('.',search.name)))+'.an1');
    dispose(show,done);
    findnext(search);
  end;}

  if paramcount>0 then new(show,laden(paramstr(1)+'.ani'))
  else new(show,init);
  if paramcount>1 then show^.berechneanimation;
  repeat
    ein:=show^.handleevent;
    case ein of
      'L':begin
        dispose(show,done);
        newscreen;
        new(show,laden(getname(300,260,'Gebe den Namen ein:')+'.ani'));
      end;
      'C':begin
        dispose(show,done);
        newscreen;
        new(show,init);
      end;
    end;
    while keypressed do ein:=readkey;
  until ein=#27;
  closegraph;
end.